(in-package :cube-modeller)

;; play animation code

(let (old-current-cube-number
      loop-animation
      animation-running)
  
  (defun start-animation (&key (endless-loop nil))
    "function to start the animation *mode*; to actually play you have to call ANIMATION-STEP"
    (setf loop-animation endless-loop)
    (setf old-current-cube-number *current-cube-number*)
    (goto-cube :first)
    (write-cube-to-device)
    (setf animation-running t))

  (defun stop-animation ()
    "function to stop the animation *mode*"
    (when animation-running
      (setf animation-running nil)
      (goto-cube old-current-cube-number)
      (write-cube-to-device))) ;; not really necessary as it is alwys done at the end of next-frame

  (defun toggle-animation-running-state (&key (endless-loop t))
      (if animation-running
	  (stop-animation)
	  (start-animation :endless-loop endless-loop)))

  (defun next-frame ()
    (if (> (1- (length *animation*))
	   *current-cube-number*)
	(progn
	  (print 'foo *trace-output*)
  
	  (goto-cube :next)
	  (write-cube-to-device))
	(progn
	  (print 'bar *trace-output*)
	  (setf animation-running nil)
	  (stop-animation))))

  (defun next-frame ()
    (if (= (1- (length *animation*)) ;; on last cube
	   *current-cube-number*)
	(if loop-animation
	    (goto-cube :first)
	    (stop-animation))
	(goto-cube :next))
    (write-cube-to-device))

  (defun animation-step ()
    (when animation-running
      (next-frame))
    (sleep-for-delay))


  (defun start-animation-process (&optional (process-name "animation loop"))
    "starts a new process which plays the animation independent from the OpenGL viewer"
    (clim-sys:make-process (lambda ()
                             (start-animation :endless-loop t)
                             (loop do (animation-step))
                             (stop-animation)
                             (destroy-process-with-name process-name))
                           :name process-name))

  (defun stop-animation-process (&optional (process-name "animation loop"))
    "destroys the animation playing process"
    (destroy-process-with-name process-name)
    (stop-animation))
  
  ) ;; of let
